#include "header.h"

static double lines[NUMLINES][4] = {
	{ -0.8, 0.8, -0.3, 0.8 }, 
	{ -0.8, -0.1, -0.2, 0.6 }, 
	{ -0.4, -0.4, -0.05, -0.35 }, 
	{ -0.05, 0.3, 0.25, -0.1 }, 
	{ 0.1, 0.85, 0.2, 0.4 }, 
	{ 0.6, 0.7, 0.8, 0.4 }, 
	{ 0.4, -0.7, 0.7, 0.05 }
};
static double colors[NUMLINES][3] = {
	{ 0.0, 0.0, 0.0 },
	{ 0.0, 0.0, 1.0 }, 
	{ 0.0, 1.0, 0.0 }, 
	{ 0.0, 1.0, 1.0 }, 
	{ 1.0, 0.0, 0.0 }, 
	{ 1.0, 0.0, 1.0 }, 
	{ 1.0, 1.0, 0.0 } 
};
void initLine() 
{
	//
}
void drawLine(int index)
{
	glColor3d(0.5, 0.5, 0.5);
	glBegin(GL_LINES);
	glVertex3d(lines[index][0], lines[index][1], 0.1);
	glVertex3d(lines[index][2], lines[index][3], 0.1);
	glEnd();
}

void get_normal(int index, double normal[2]) {
	double len;
	normal[0] = lines[index][1] - lines[index][3];
	normal[1] = lines[index][2] - lines[index][0];
	len = sqrt(normal[0] * normal[0] + normal[1] * normal[1]);
	normal[0] /= len;
	normal[1] /= len;
}
void drawLineDistMap(int index)
{
	double normal[2];
	const double kSize = 3000.0;

	double _num6 = -kSize; 

	get_normal(index, normal);
	glColor3dv(colors[index]);
	glPushMatrix();
	glTranslated(lines[index][0], lines[index][1], _num6); 
	glutSolidCone(kSize, kSize, 64, 1);
	glPopMatrix();

	glPushMatrix();	
	glTranslated(lines[index][2], lines[index][3], _num6); 
	glutSolidCone(kSize, kSize, 64, 1);
	glPopMatrix();	

	glBegin(GL_QUADS); 
	glVertex3d(lines[index][0], lines[index][1], 0);
	glVertex3d(lines[index][0] + normal[0] * kSize, lines[index][1] + normal[1] * kSize, _num6);
	glVertex3d(lines[index][2] + normal[0] * kSize,	lines[index][3] + normal[1] * kSize, _num6);
	glVertex3d(lines[index][2], lines[index][3], 0);

	glVertex3d(lines[index][0], lines[index][1], 0);
	glVertex3d(lines[index][0] - normal[0] * kSize,	lines[index][1] - normal[1] * kSize, _num6);
	glVertex3d(lines[index][2] - normal[0] * kSize,	lines[index][3] - normal[1] * kSize, _num6);
	glVertex3d(lines[index][2], lines[index][3], 0);
	glEnd();
}
void drawLineDistMap()
{
	for (int i=0; i<NUMLINES; ++i) { drawLineDistMap(i); drawLine(i); }
}