#include "header.h"

int winWidth	= 512;
int winHeight	= 512;
int vSize		= 1;	// viewport.. gluOrtho2D(-vpSize, vpSize, -vpSize, vpSize)
int vzSize		= 5;

float *depth;			// depth buffer array
char *colors, *colors2;	// frame buffer array -> pixel

void initGL()
{
	glClearColor(0.0, 0.0, 0.0, 1.0);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(-vSize, vSize, -vSize, vSize, -vzSize, vzSize);

	glMatrixMode(GL_MODELVIEW);	
	glLoadIdentity();

	glEnable(GL_DEPTH_TEST);
	depth = (float*)malloc(winWidth*winHeight*sizeof(float));
	// pixel RGB 
	colors = (char*)malloc(3*winWidth*winHeight*sizeof(char));
	colors2 = (char*)malloc(3*winWidth*winHeight*sizeof(char));
}
float getDistance(int idx, float *depth);
void applyDistMap(float *dist, char *colors, char *colors2)
{
	// distance  color ϱ ؼ ߰
	// display callback Լ о pixel 
	memcpy(colors2, colors, 3*winWidth*winHeight*sizeof(char));
	
	for (int i = 0; i < winHeight; i++)
	{
		for (int j = 0; j < winWidth; j++)
		{
			// distance   ..
			int idx = i*winWidth + j;
			float dist = getDistance(idx, depth);
			dist = dist * 128;
			colors2[idx*3  ] += (colors2[idx*3  ] > 120) ? 0 : (int)dist;
			colors2[idx*3+1] += (colors2[idx*3+1] > 120) ? 0 : (int)dist;
			colors2[idx*3+2] += (colors2[idx*3+2] > 120) ? 0 : (int)dist;
		}
	}
}
void displayCB()
{
	glClearColor(1.f, 1.f, 1.f, 1.f);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

#if _TYPE == 0
	drawLineDistMap();
#elif _TYPE == 1
	drawArcDispMap();
#endif
	// depth buffer  
	glReadPixels(0, 0, winWidth, winHeight, GL_DEPTH_COMPONENT, GL_FLOAT, depth);
	// frame buffer  
	glReadPixels(0, 0, winWidth, winHeight, GL_RGB, GL_BYTE, colors);
#ifndef _CONEDIFFCOLOR
	applyDistMap(depth, colors, colors2);
	glDrawPixels(winWidth, winHeight, GL_RGB, GL_BYTE, colors2);
#endif

	glutSwapBuffers();
}
float getDistance(int idx, float *depth)
{
	//  Լ   depth  0 1  .
	// viewport z  -1~1  1~0 
	float dist = vzSize*2*(depth[idx]-0.5);
	if (dist < 0) dist = 0; // arc or line pixel...
	return dist;
}
int getObjectId(int idx, char *colors)
{
#ifndef _CONEDIFFCOLOR
	int r = (colors[idx*3  ] > 120) ? 1 : 0;
	int g = (colors[idx*3+1] > 120) ? 1 : 0;
	int b = (colors[idx*3+2] > 120) ? 1 : 0;
#else
	int r = (colors[idx*3  ] > 50) ? 1 : 0;
	int g = (colors[idx*3+1] > 50) ? 1 : 0;
	int b = (colors[idx*3+2] > 50) ? 1 : 0;
#endif
	return r*4 + g*2 + b;
}
void mouseCB(int button, int state, int x, int y)
{
	if (GLUT_LEFT_BUTTON == button)
	{
		if (state == GLUT_DOWN)
		{
			int idx = (winHeight-y)*winWidth + x;
			int objId = getObjectId(idx, colors);
			float dist = getDistance(idx, depth);
			printf("\n- id: %d, dist: %f", objId, dist);
		}
	}
}
void keyboardCB(unsigned char key, int x, int y)
{
	switch(key)
	{
	case (27):
		free(depth);
		free(colors);
		free(colors2);
		freeArc();
		exit(0);
		break;
	default: break;
	}
}
void main(int argc, char **argv) 
{
	glutInit(&argc, argv);
	glutInitWindowSize(winWidth, winHeight);
	glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGB|GLUT_DEPTH|GLUT_MULTISAMPLE);
	glutCreateWindow("OpenGL test");

	initGL();
	initLine();
	initArc();

	glutDisplayFunc(displayCB);
	glutMouseFunc(mouseCB);
	glutKeyboardFunc(keyboardCB);
	// frame buffer ũ⿡  array Ҵ window ũ    .
//	glutReshapeFunc(..)	// do not reshape !!

	glutMainLoop();
}